; -*- Scheme -*-

(define no-valid-func (lambda (x) (error "This type does not have any valid function")))
(define no-c2scm-func (lambda (x) (error "This type does not have any c2scm function")))

(register-type
 'gluTesselator
 (make-type "gluTesselator" "gluTesselator*"
	    (lambda (x) (@@ "SCM_TESSP(~a)" x))
	    (lambda (x) (@@ "SCM_GLU_TESSELATOR(~a)" x))
	    no-c2scm-func))

(register-composite-realizer 'f-ext-array
  (lambda (form)
    (let
	((maxsize	(cadr form))
	 (enum-name	(caddr form)))
    (make-type (@@ "f-e-array:~a:~a" maxsize enum-name) "GLfloat*"
	  no-valid-func
	  (lambda (x pos subr)
	    (@@ "sgl_scm2fext_array (~a, tmp_~a, ~a, sgtk_~a_info, ~a, ~a)"
		x x maxsize (func-name enum-name) pos subr))
	  no-c2scm-func
	  'scm2c-does-type-checking #t
	  'c-definition (lambda (t p)
			  (@ "  GLfloat* c_~a;~%" (cadr p))
			  (@ "  GLfloat  tmp_~a [~a];~%" (cadr p) maxsize))))))

(define (x-array-register-realizer name cname char-id)
  (register-composite-realizer name
     (lambda (form)
       (let
	   ((maxsize	(cadr form))
	    (exact-size	(if (and (pair? (cddr form)) (eq? (caddr form) 'exact-size))
			    "TRUE"
			    "FALSE")))
	 (make-type (@@ "~a:~a:~a" name maxsize exact-size) (@@ "~a*" cname)
		    no-valid-func
		    (lambda (x pos subr)
		      (@@ "sgl_scm2~a_array (~a, tm~a, ~a, ~a, ~a, ~a)"
			  char-id x x maxsize exact-size pos subr))
		    no-c2scm-func
		    'scm2c-does-type-checking #t
		    'c-definition (lambda (t p)
				    (@ "  ~a* c_~a;~%" cname (cadr p))
				    (@ "  ~a  tmp_~a [~a];~%" cname (cadr p) maxsize)))))))


(x-array-register-realizer 'b-array "GLbyte" "b")
(x-array-register-realizer 'ub-array "GLubyte" "ub")
(x-array-register-realizer 's-array "GLshort" "s")
(x-array-register-realizer 'i-array "GLint" "i")
(x-array-register-realizer 'u-array "GLuint" "u")
(x-array-register-realizer 'f-array "GLfloat" "f")
(x-array-register-realizer 'd-array "GLdouble" "d")

