#! /usr/bin/perl

sub gl_extract
  {
    ($underlines, $in, $out, $modname) = @_;
    
    open IN, $in;
    open OUT, ">$out";

    print OUT "; -*- Scheme -*-
; This file was generated from mesa headers using enum-from-mesa.pl

(define-module (open-gl $modname))
";

    $inside = 0;

    while ( <IN> )
      {

	$inside = 1 if ( /enum\s*{/ );
        $inside = 0 if (($inside == 1) && ( /}/ ));
		    
	if ($inside == 1)
	  {
	    if ( m!/\*\s(.*)\s*\*/! )
	      {
		print OUT "\n;;; $1\n\n";
	      }

	    if ( /^\s*([A-Za-z_0-9]+)\s*=\s*([0-9a-fA-FxX]+)\s*,/ )
	      {
		$name = $1;
		$number = $2;

		$number = ( $number =~ /0x/i ) ?  hex $number : $number;
		$name =~ s/_/-/g if ($underlines == 1);

		print OUT "(define $name	$number)\n";
	      }
	  }
      }
  }


gl_extract 0, "/usr/X11/include/GL/gl.h", "open-gl/gl_enum.scm", "gl_enum";
gl_extract 1, "/usr/X11/include/GL/gl.h", "open-gl/gl-enum.scm", "gl-enum";

gl_extract 0, "/usr/X11/include/GL/glu.h", "open-gl/glu_enum.scm", "glu_enum";
gl_extract 1, "/usr/X11/include/GL/glu.h", "open-gl/glu-enum.scm", "glu-enum";
