#! /usr/bin/perl

$no_array_parameters = 1;

open RJ, ">>rejected.lines";

while (<>)
  {
    if ( /WINGDIAPI|GLU?API/ )
      {
	$line = $_;


	while ($_ !~ /;/)
	  {
	    $line .= $_ = <>;
	  }
	
	$_ = $line;

#	print "Input line: ", $_;

	if (! /(?:WINGDIAPI|GLU?API)\s+(\S+)\s+(?:GL)?APIENTRY\s+(\S+)\s*\(([^\)]+)\)/ )
	  {
	    print RJ "Bad function line: ", $_;
	  }
	else
	  {
	    $ret = $1;
	    $name = $2;
	    $params = $3;

	    $ret = "none" if ($1 eq "void");
	    $ret = "bool" if ($1 eq "GLboolean");


	    if ($name =~ /^(.*)(EXT|SGIS|MESA|ARB)$/)
	      {
		$firstname = $1;
		$extension = $2;
	      }
	    else
	      {
		$firstname = $name;
		$extension = "";
	      }


	    $output = "(define-func " . $name . "\n  " . $ret . "\n";

	    $_ = $params;
#	    print "Parameters: ", $_, "\n\n";

	    s/\n//g;

	    s/^\s*//g;
	    s/\s*$//g;

	    if ($_ eq "void")
	      {
		$output .= "  ()";
	      }
	    else
	      {
		s/\s*const\s*//g;
		s/GLboolean/bool/g;

		s/\s+/\t\t/g;
		s/,\s*/\)\n   \(/g;

		$output .= "  ((" . $_ . "))";
	      }

	    if ($extension ne "")
	      {
		$firstname =~ s/([A-Z])/-$1/g;
		
		$output .= "\n  (scm-name \"" . lc ($firstname) . "-" . $extension . "\")";
	      }

	    $output .= ")";

	    if (($no_array_parameters == 1) && ($firstname =~ /v$/))
	      {
		$output =~ s/^/; /gm;
		$output = "; FIXME !!!\n;\n" . $output;
	      }

	    print $output, "\n\n";
	  }
      }
    else
      {
	print RJ "Rejected: ", $_;
      }
  }

close RJ;
