(use-modules
 (open-gl glu)
 (open-gl gl)
 (open-gl simple-gl-window))


(define tess (glu-new-tess))

(glu-tess-callback tess 'begin gl-begin)
(glu-tess-callback tess 'vertex gl-vertex3dv) 
(glu-tess-callback tess 'end  gl-end)

(define vertices1
  '(#(10 50 0)
    #(50 90 0)
    #(90 50 0)
    #(50 10 0)))

; for vertex functions it does not metter if vertices come as
; list or vector (or uniform array)

(define vertices2
   '(#(60 60 0)
     #(40 60 0)
     #(40 40 0)
     #(60 40 0)))

(define (send-vertex x)
  (glu-tess-vertex tess x x))

(simple-gl-context "GLU 1.2 Polygons"

	; expose (= redraw) event

		  (lambda (context)
		    (gl-clear '(color-buffer))
		    (gl-color3d 1 1 1)
		    
		    (glu-tess-begin-polygon tess tess)

		      (glu-tess-begin-contour tess)
		      (for-each send-vertex vertices1)
		      (glu-tess-end-contour tess)

;		       (glu-tess-begin-contour tess)
;		       (for-each send-vertex vertices2)
;		       (glu-tess-end-contour tess)

		    (glu-tess-end-polygon tess))

	; realize (= setup) event

		  (lambda (context)
		    (gl-matrix-mode 'projection)
		    (gl-load-identity)
		    (glu-ortho2d 0 100 100 0)
		    (gl-matrix-mode 'modelview)
		    (gl-load-identity)
		    (gl-clear-color 0 0 0 1))

	; init size
		  
		  'size '(200 200))
			  
(simple-gl-run)
